.intel_syntax noprefix
.text
.globl obrni

#void obrni(long*, int);
#            rdi   esi
obrni:
	enter 0,0

	#koristicemo indeksni pristup za prolazak kroz niz

	#u r8d cuvamo indeks levog elementa za swap (inicijalno 0)
	xor r8d, r8d

	#u esi cuvamo indeks desnog elementa za swap (inicijalno n-1)
	#u esi se vec nalazi n (duzina niza), pa je samo umanjujemo za 1
	dec esi
	
petlja:
	#ukoliko su indeksi levog i desnog elementa za swap jednake
	#(sredisnji element niza sa parnim brojem elemenata) ili su
	#presli na suprotnu polovinu niza (mioisli se), zavrsavamo
	cmp r8d, esi
	jge kraj

	#zamenjujemo vrednosti levog i desnog elementa
	mov rdx, [rdi+r8*8]
	mov rcx, [rdi+rsi*8]
	mov [rdi+r8*8], rcx
	mov [rdi+rsi*8], rdx

	#uvecavamo indeks levog elementa za swap
	inc r8d

	#umanjujemo indeks desnog elementa za swap
	dec esi
	
	jmp petlja

kraj:
	leave
	ret

