.intel_syntax noprefix
.text
.global suma


#INDEKSNI PRISTUP: [B + I*S] omogucuje nam pristup I-tom elementu niza
#koji pocinje na adresi B i kome je svaki element velicine S (u bajtovima)

#int suma(int*, int);
#eax      rdi   esi
suma:
	enter 0,0

	#u eax cemo sracunati sumu elemenata niza (inicijalno 0)
	xor eax, eax

	#registar ecx koristicemo kao indeks (inicijalno 0) 
	xor ecx, ecx

petlja:
	#ukoliko je indeks >= n zavrsavamo
	cmp ecx, esi
	jge kraj

	#na tekucu sumu dodajemo vrednost I-tog elementa niza
	#NAPOMENA: u izrazu za sracunavanje adrese I-tog elementa 
	#niza na mesto indeksa umesto ecx koristimo ceo registar 
	#rcx kako bismo imali sabiranje zapisa jednakih sirina!
	add eax, [rdi+rcx*4]

	#uvecavamo indeks za sledecu iteraciju
	inc ecx

	jmp petlja

kraj:
	#suma se vec nalazi u registru eax gde i treba 

	leave
	ret
