.intel_syntax noprefix
.text
.global lin_pretraga

#int lin_pretraga(short*, int, short);
#eax               rdi    esi    dx
lin_pretraga:
	enter 0, 0

	#koristicemo indeksni pristup za prolazak kroz niz
	
	#u r8d cuvamo indeks tekuceg elementa (inicijalno 0)
	xor r8d, r8d

petlja:
	#ukoliko smo obisli ceo niz to znaci da nismo pronasli trazeni element
	cmp r8d, esi
	ja nije_pronadjen

	#poredimo tekuci element sa trazenim
	cmp [rdi+r8*2], dx
	je jeste_pronadjen

	#uvecavamo indeks za 1
	inc r8d
	
	jmp petlja	

nije_pronadjen:
	#vracamo proizvoljnu negativnu vrednost (nevalidan indeks)
	mov eax, -1

	jmp kraj

jeste_pronadjen:
	#vracamo indeks pronadjenog elementa
	mov eax, r8d

kraj:
	leave
	ret
